HDU 3714 Error Curves(三分)

Problem Description

Josephina is a clever girl and addicted to Machine Learning recently. She
pays much attention to a method called Linear Discriminant Analysis, which
has many interesting properties.
In order to test the algorithm's efficiency, she collects many datasets.
What's more, each data is divided into two parts: training data and test
data. She gets the parameters of the model on training data and test the
model on test data. To her surprise, she finds each dataset's test error curve is just a parabolic curve. A parabolic curve corresponds to a quadratic function. In mathematics, a quadratic function is a polynomial function of the form f(x) = ax2 + bx + c. The quadratic will degrade to linear function if a = 0.

It's very easy to calculate the minimal error if there is only one test error curve. However, there are several datasets, which means Josephina will obtain many parabolic curves. Josephina wants to get the tuned parameters that make the best performance on all datasets. So she should take all error curves into account, i.e., she has to deal with many quadric functions and make a new error definition to represent the total error. Now, she focuses on the following new function's minimum which related to multiple quadric functions. The new function F(x) is defined as follows: F(x) = max(Si(x)), i = 1...n. The domain of x is [0, 1000]. Si(x) is a quadric function. Josephina wonders the minimum of F(x). Unfortunately, it's too hard for her to solve this problem. As a super programmer, can you help her?

 

Input 

he input contains multiple test cases. The first line is the number of cases T (T < 100). Each case begins with a number n (n ≤ 10000). Following n lines, each line contains three integers a (0 ≤ a ≤ 100), b (|b| ≤ 5000), c (|c| ≤ 5000), which mean the corresponding coefficients of a quadratic function.

 

Output

For each test case, output the answer in a line. Round to 4 digits after the decimal point.

 

Sample Input

2
1
2 0 0
2
2 0 0
2 -4 2

 

Sample Output

0.0000
0.5000

 

题意:

给n个二项式抛物线f(i)的a[i], b[i],  c[i], 定义F(i)= max(f(i)) ,求F(x)在区间[0,1000]上的最小值。

 

思路:

因为a>=0,所以当a为0时为直线,当a>0时所有抛物线的开口都向上,即可得F(x)的图像也是先单调下降再单调上升。

每次取区间中点mid和中点与右边界的中点midd,看F(x)在两点处的值,如果F(mid)>F(midd)(有两种情况,一种是F(mid)和F(midd)都在最低点左侧,另一种是F(mid)在最低点左侧,F(midd)在最低点右侧)就更新左边界为mid,否则如果F(mid)<F(midd)(有两种情况,一种是F(mid)和F(midd)都在最低点右侧,另一种是F(mid)在最低点左侧,F(midd)在最低点右侧)更新右边界为midd,最后F(mid)就是答案

 

注:三分求解,三分法不仅适用于凸函数,还适用于所有单峰函数

一般对于实数的写法  while(left+eps<right)   eps=1e-15

 

 

 

代码:

#include <cstdio>
#define maxn 10010
#define eps 1e-15
#include <algorithm>
using namespace std;
double a[maxn],b[maxn],c[maxn];
int n;
double cal(double x)
{
    int i;
    double ans=a[0]*x*x+b[0]*x+c[0];
    for(i=1;i<n;i++)
        ans=max(ans,a[i]*x*x+b[i]*x+c[i]);
    return ans;
}
double solve()
{
    double left,right,mid,midd;
    double midzhi,middzhi;
    left=0.0;right=1000.0;
    while(left+eps<right)
    {
        mid=(left+right)/2;
        midd=(mid+right)/2;
        midzhi=cal(mid);
        middzhi=cal(midd);
        if(midzhi>middzhi)
            left=mid;
        else
            right=midd;
    }
    return cal(left);
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        int i;
        double ans=0.0;
        scanf("%d",&n);
        for(i=0;i<n;i++)
            scanf("%lf%lf%lf",&a[i],&b[i],&c[i]);
        ans = solve();
        printf("%.4lf\n",ans);
    }
    return 0;
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值